﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
		
	import flash.events.ProgressEvent;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.events.IOErrorEvent;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	import com.lorentz.processing.ProcessExecutor;
	import com.lorentz.SVG.display.SVGDocument;
	import com.lorentz.SVG.events.SVGEvent;
	
	import com.actionscriptfacile.ui.text.UITextField;

	import com.demonsters.debugger.MonsterDebugger;


	public class Main extends Sprite
	{
		private var oTxtProgress : UITextField;
		private var oSVGDoc : SVGDocument;
		
		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			ProcessExecutor.instance.initialize(stage);// init de la librairie SVG
			
			this.buildUI();
			
			/* chargement du fichier svg */
			var oURLoader:URLLoader = new URLLoader();
			oURLoader.addEventListener(Event.COMPLETE, onLoadComplete);
			oURLoader.addEventListener(ProgressEvent.PROGRESS, onLoadProgress);
			oURLoader.addEventListener(IOErrorEvent.IO_ERROR, onLoadError);
			
			oURLoader.load(new URLRequest("http://www.actionscript-facile.com/ressources/images/banner-as3-facile.svg"));
		}

		
		/**
		 * Création de l'interface.
		 * 
		 */
		private function buildUI() : void
		{
			oTxtProgress = new UITextField();
			oTxtProgress.x = 233;
			oTxtProgress.y = 233;
			oTxtProgress.text = "En cours de construction...";
			oTxtProgress.selectable = false;
			oTxtProgress.autoSizeLeft();
			oTxtProgress.alignCenter(); // centre le texte
			oTxtProgress.changeFormat("size", 14);// changement de la taille de la police du texte
			oTxtProgress.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtProgress.changeFormat("bold", true);// changement de la taille de la police du texte
			oTxtProgress.changeFormat("color", Math.random() * 0X00FFFFFF);// changement de la couleur
			
			this.addChild(oTxtProgress);
		}
		
		
		/**
		 * Progression du chargement du fichier SVG.
		 * 
		 */
		private function onLoadProgress(event : ProgressEvent) : void
		{
			//MonsterDebugger.trace(this,event.target.bytesLoaded+" chargés sur "+event.target.bytesTotal);
			
			var nProgress:Number = Math.round( event.target.bytesLoaded * 100 / event.target.bytesTotal );
			oTxtProgress.text = "Chargement en cours : "+String(nProgress)+" %";
		}
		
		
		/**
		 * Chargement du fichier SVG terminé.
		 * 
		 */
		private function onLoadComplete(event : Event) : void
		{
			MonsterDebugger.trace(this, "onLoadComplete");
			MonsterDebugger.trace(this, event);
			
			oTxtProgress.text = "Création de l'affichage en cours...";
			
			// création d'un objet SVG
			oSVGDoc = new SVGDocument();
			oSVGDoc.addEventListener(SVGEvent.PARSE_COMPLETE, onResizeSVG);
			oSVGDoc.parse(event.currentTarget.data);// parse le fichier xml / SVG

			this.addChild(oSVGDoc);// ajout sur la scène.
		}
		
		
		/**
		 * Construction du fichier SVG terminée.
		 * 
		 */
		private function onResizeSVG(event : SVGEvent) : void
		{
			MonsterDebugger.trace(this, "onResizeSVG");
			MonsterDebugger.trace(this, event);
			
			oTxtProgress.text = "Déplacement du SVG en cours...";
			
			// modification des propriétés du fichier SVG
			oSVGDoc.svgX = "63";
			oSVGDoc.svgY = "63";
			
			oTxtProgress.visible = false;
		}
		
		
		/**
		 * En cas d'erreur de chargement.
		 * 
		 */
		private function onLoadError(event : IOErrorEvent) : void
		{
			MonsterDebugger.trace(this, "onLoadError");
			MonsterDebugger.trace(this, event);
		}

	}
}
